Revision dca45efbe3c870a4ad2107fe625109b3765c0fea authored by Linus Torvalds on 14 October 2022, 20:22:14 UTC, committed by Linus Torvalds on 14 October 2022, 20:22:14 UTC
Pull sound fixes from Takashi Iwai:
 "Here are a few remaining patches for 6.1-rc1.

  The major changes are the hibernation fixes for HD-audio CS35L41 codec
  and the USB-audio small fixes against the last change. In addition, a
  couple of HD-audio regression fixes and a couple of potential
  mutex-deadlock fixes with OSS emulation in ALSA core side are seen"

* tag 'sound-fix-6.1-rc1' of git://git.kernel.org/pub/scm/linux/kernel/git/tiwai/sound:
  ALSA: hda: cs35l41: Support System Suspend
  ALSA: hda: cs35l41: Remove suspend/resume hda hooks
  ALSA: hda/cs_dsp_ctl: Fix mutex inversion when creating controls
  ALSA: hda: hda_cs_dsp_ctl: Ensure pwr_lock is held before reading/writing controls
  ALSA: hda: hda_cs_dsp_ctl: Minor clean and redundant code removal
  ALSA: oss: Fix potential deadlock at unregistration
  ALSA: rawmidi: Drop register_mutex in snd_rawmidi_free()
  ALSA: hda/realtek: Add Intel Reference SSID to support headset keys
  ALSA: hda/realtek: Add quirk for ASUS GV601R laptop
  ALSA: hda/realtek: Correct pin configs for ASUS G533Z
  ALSA: usb-audio: Avoid superfluous endpoint setup
  ALSA: usb-audio: Correct the return code from snd_usb_endpoint_set_params()
  ALSA: usb-audio: Apply mutex around snd_usb_endpoint_set_params()
  ALSA: usb-audio: Avoid unnecessary interface change at EP close
  ALSA: hda: Update register polling macros
  ALSA: hda/realtek: remove ALC289_FIXUP_DUAL_SPK for Dell 5530
2 parent s 5964c92 + 8867282
Raw File
check-local-export
#!/bin/sh
# SPDX-License-Identifier: GPL-2.0-only
#
# Copyright (C) 2022 Masahiro Yamada <masahiroy@kernel.org>
# Copyright (C) 2022 Owen Rafferty <owen@owenrafferty.com>
#
# Exit with error if a local exported symbol is found.
# EXPORT_SYMBOL should be used for global symbols.

set -e
pid=$$

# If there is no symbol in the object, ${NM} (both GNU nm and llvm-nm) shows
# 'no symbols' diagnostic (but exits with 0). It is harmless and hidden by
# '2>/dev/null'. However, it suppresses real error messages as well. Add a
# hand-crafted error message here.
#
# TODO:
# Use --quiet instead of 2>/dev/null when we upgrade the minimum version of
# binutils to 2.37, llvm to 13.0.0.
# Then, the following line will be simpler:
#   { ${NM} --quiet ${1} || kill 0; } |

{ ${NM} ${1} 2>/dev/null || { echo "${0}: ${NM} failed" >&2; kill $pid; } } |
${AWK} -v "file=${1}" '
BEGIN {
	i = 0
}

# Skip the line if the number of fields is less than 3.
#
# case 1)
#   For undefined symbols, the first field (value) is empty.
#   The outout looks like this:
#     "                 U _printk"
#   It is unneeded to record undefined symbols.
#
# case 2)
#   For Clang LTO, llvm-nm outputs a line with type t but empty name:
#     "---------------- t"
!length($3) {
	next
}

# save (name, type) in the associative array
{ symbol_types[$3]=$2 }

# append the exported symbol to the array
($3 ~ /^__ksymtab_/) {
	export_symbols[i] = $3
	sub(/^__ksymtab_/, "", export_symbols[i])
	i++
}

END {
	exit_code = 0
	for (j = 0; j < i; ++j) {
		name = export_symbols[j]
		# nm(3) says "If lowercase, the symbol is usually local"
		if (symbol_types[name] ~ /[a-z]/) {
			printf "%s: error: local symbol %s was exported\n",
				file, name | "cat 1>&2"
			exit_code = 1
		}
	}

	exit exit_code
}'

exit $?
back to top